         PRINT NOGEN
         BEGIN NAME=QGKA,IBM=YES,AMODE=64
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
         SPACE

         L     R1,EBW000          Get number of restarts left
         L     R2,EBW004          Get number of restarts before switch

         C     R2,ZERO            Is restarts_before_switch zero?
         BE    SWITCH             Yes -> Switch to the CSO

         C     R1,ZERO            Is restarts_left zero?
         BE    FINAL              Yes -> Do the final buffer check

         B     AGAIN              Create another tracegroup and restart


SWITCH   DS    0H

         LA    R3,CSO             Get pointer to CSO program name

         CPROC RETURN=void,alter_tracegroup,(p)
         CALLC alter_tracegroup(R3) Change the CSO program's tracegroup

         S     R1,ONE             Decrement restarts_left
         ST    R1,EBW000          Store the value for the CSO

         S     R2,ONE             restarts_before_switch = -1
         ST    R2,EBW004          Store the value for the CSO

         ENTDC QGKC               Jump to the CSO


AGAIN    DS    0H

         LA    R3,BSO             Get pointer to BSO program name

         CPROC RETURN=void,alter_tracegroup,(p)
         CALLC alter_tracegroup(R3) Change this program's tracegroup

         S     R1,ONE             Decrement restarts_left
         ST    R1,EBW000          Store the value for next time

         C     R2,=F'-1'          Is restarts_before_switch -1?
         BE    RESTART            Yes -> skip the decrement and restart
         S     R2,ONE             Decrement restarts_before_switch
         ST    R2,EBW004          Store the value for next time


RESTART  DS    0H
         ENTDC QGKA               Restart this program


FINAL    DS    0H
         LGHI  R2,X'1000'         Get offset to ECB Page 2
         LGHI  R3,X'2000'         Get offset to ECB Page 3

         LG    R4,CE3CURMH(R3,R9) Get current macro trace buffer
         LG    R5,CE3CURCH(R3,R9) Get current C function trace buffer

         LG    R1,CE2TRLIST(R2,R9) Get pointer to buffer list struct

         USING BUFLIST,R1         Access the struct as a BUFLIST DSECT
         CG    R4,M_BUFFER        Is current macro buffer the first?
         BNE   WRONG              If not -> ERROR
         CG    R5,C_BUFFER        Is current C buffer the first?
         BNE   WRONG              If not -> ERROR


RIGHT    DS    0H
         WTOPC TEXT='CORRECT BUFFERS USED',ROUT=PRC,EBROUT=NO
         B     DONE

WRONG    DS    0H
         WTOPC TEXT='ERROR: INCORRECT BUFFERS USED',LET=E,NUM=1,       X
               ROUT=PRC,EBROUT=NO


DONE     DS    0H
         DROP  R1

EXIT     DS    0H
         EXITC ,

         FINIS

CSO      DC    C'QGKC'     Name of the CSO program
         DC    F'0'        End of string NUL byte
BSO      DC    C'QGKA'     Name of the BSO program
         DC    F'0'        End of string NUL byte

ZERO     DC    F'0'        The value 0
ONE      DC    F'1'        The value 1

BUFLIST  DSECT             Equivalent to the iecb_tr_buffer_list struct
M_BUFFER DS    FL8         Pointer to the macro trace buffer
C_BUFFER DS    FL8         Pointer to the C function trace buffer

         END
