/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <tpf/tpfapi.h>
#include <tpf/c_idspat.h>
#include <tpf/c_cinfc.h>


#define CSO_PROGRAM QGKC
#define BSO_PROGRAM QGKA
#define NO_SWITCH   -1
#define BUFFER_SIZE 50
#define PARAMETER_LENGTH 8

const char *const CSO_STRING = "QGKC";
const char *const BSO_STRING = "QGKA";


/* Structure definition taken from collatetrace.c */
struct  iecb_tr_buffer_list
{
   struct ictrace_header *macro_tr_buf;   /* ptr to macro trace buffer*/
   struct ictrace_header *cfunc_tr_buf;   /* ptr to C func trace buf  */
};


/*****************************************************************************/
/* alter_tracegroup - changes the tracegroup for the program specified by    */
/*                    the program_name parameter to the form  TGi, where i   */
/*                    is the index of the new tracegroup.                    */
/*****************************************************************************/
void alter_tracegroup( const char *const program_name );
